% Metodo de Householder para reducir
% A a tridiagonal o Hessenberg superior
% usado en el clculo de autovalores
%
% Uso: [A] = houseig(A)
% A es la matriz resultante

function [A] = houseig(A)

[m n] = size(A);

for i=1:n-1,
    w = zeros(n,1);
    v = A(i+1:n,i);
    nor = norm(v);
    if nor > 10*eps;
        signo = sign(v(1));
        if abs(v(1)) < 10*eps,
            signo = 1;
        end;
        v(1) = v(1) + signo*nor;
	w(i+1:n) = v;
	cociente = 2*(w*w')/(w'*w);
        A = A-cociente*A-A*cociente+cociente*A*cociente;
    end;
end;
