% Implementacin del Mtodo de Runge-Kutta de segundo orden
% Metodo de Euler modificado
% Uso: [t,y,dy]=eulermod(funcion,inicio,fin,alfa,paso)
%
% (C) - Carlos Garcia Argos, 20/VIII/2001

function [ts,ys,fs]=eulermod(f,inicio,fin,alfa,h)

if nargin<5
   disp('Faltan argumentos de entrada');
   return;
else
   ts=inicio:h:fin;
   ys(:,1)=alfa;
   n=(fin-inicio)/h;
   for i=1:n
      k1=feval(f,ts(i),ys(:,i));
      k2=feval(f,ts(i)+h*(2/3),ys(:,i)+h*(2/3)*k1);
      fs(:,i)=k1;
      ys(:,i+1)=ys(:,i)+(k1+k2)*h/4;
   end;
end;
