% Implementacin del Mtodo de Runge-Kutta de segundo orden
% Metodo de Heun
% Uso: [t,y,dy]=heun(funcion,inicio,fin,alfa,paso)
%
% (C) - Carlos Garcia Argos, 20/VIII/2001

function [ts,ys,fs]=heun(f,inicio,fin,alfa,h)

if nargin<5
   disp('Faltan argumentos de entrada');
   return;
else
   ts=inicio:h:fin;
   ys(:,1)=alfa;
   n=(fin-inicio)/h;
   for i=1:n
      k1=feval(f,ts(i),ys(:,i));
      k2=feval(f,ts(i)+h/2,ys(:,i)+(h*k1)/2);
      fs(:,i)=k1;
      ys(:,i+1)=ys(:,i)+k2*h;
   end;
end;
