% Implementacin del Mtodo de Runge-Kutta de tercer orden
% Metodo de Nystrom
% Uso: [t,y,dy]=nystrom(funcion,inicio,fin,alfa,paso)
%
% (C) - Carlos Garcia Argos, 20/VIII/2001

function [ts,ys,fs]=nystrom(f,inicio,fin,alfa,h)

if nargin<5
   disp('Faltan argumentos de entrada');
   return;
else
   ts=inicio:h:fin;
   ys(:,1)=alfa;
   n=(fin-inicio)/h;
   for i=1:n
      k1=feval(f,ts(i),ys(:,i));
      k2=feval(f,ts(i)+h*(2/3),ys(:,i)+h*(2/3)*k1);
      k3=feval(f,ts(i)+h*(2/3),ys(:,i)+h*(2/3)*k2);
      fs(:,i)=k1;
      ys(:,i+1)=ys(:,i)+(2*k1+3*k2+3*k3)*h/8;
   end;
end;
