% Implementacion del Metodo de Runge-Kutta de quinto orden
% Metodo A de orden 5 con 6 evaluaciones
% Uso: [t,y,dy]=rk56a(funcion,inicio,fin,alfa,paso)
%
% (C) - Carlos Garcia Argos, 20/VIII/2001

function [ts,ys,fs]=rk56a(f,inicio,fin,alfa,h)

if nargin<5
   disp('Faltan argumentos de entrada');
   return;
else
   ts=inicio:h:fin;
   ys(:,1)=alfa;
   n=(fin-inicio)/h;
   for i=1:n
      k1=feval(f,ts(i),ys(:,i));
      k2=feval(f,ts(i)+h,ys(:,i)+h*k1);
      k3=feval(f,ts(i)+h,ys(:,i)+(k1+k2)*h/2);
      k4=feval(f,ts(i)+h/4,ys(:,i)+h*(14*k1+5*k2-3*k3)/64);
      k5=feval(f,ts(i)+h/3,ys(:,i)+h/96*(-12*k1-12*k2+8*k3+64*k4));
      k6=feval(f,ts(i)+h*(3/4),ys(:,i)+h/64*(-9*k2+5*k3+16*k4+36*k5));
      fs(:,i)=k1;
      ys(:,i+1)=ys(:,i)+(7*k1+7*k3+32*k4+12*k5+32*k6)*h/90;
   end;
end;
