% Implementacion del Metodo de Runge-Kutta de quinto orden
% Metodo B de orden 5 con 6 evaluaciones
% Uso: [t,y,dy]=rk56b(funcion,inicio,fin,alfa,paso)
%
% (C) - Carlos Garcia Argos, 20/VIII/2001

function [ts,ys,fs]=rk56b(f,inicio,fin,alfa,h)

if nargin<5
   disp('Faltan argumentos de entrada');
   return;
else
   ts=inicio:h:fin;
   ys(:,1)=alfa;
   n=(fin-inicio)/h;
   for i=1:n
      k1=feval(f,ts(i),ys(:,i));
      k2=feval(f,ts(i)+h/2,ys(:,i)+h*k1/2);
      k3=feval(f,ts(i)+h/4,ys(:,i)+(k1+k2)*h/8);
      k4=feval(f,ts(i)+h/2,ys(:,i)+h*k3/2);
      k5=feval(f,ts(i)+h*(3/4),ys(:,i)+h/16*(-3*k2+6*k3+9*k4));
      k6=feval(f,ts(i)+h,ys(:,i)+h/7*(k1+4*k2+6*k3-12*k4+8*k5));
      fs(:,i)=k1;
      ys(:,i+1)=ys(:,i)+(7*k1+32*k3+12*k4+32*k5+7*k6)*h/90;
   end;
end;
