% Implementacin del Mtodo de Runge-Kutta de cuarto orden
% Uso: [t,y,dy]=rkc4(funcion,inicio,fin,alfa,paso)
%
% (C) - Carlos Garcia Argos, 20/VIII/2001

function [ts,ys,fs]=rkc4(f,inicio,fin,alfa,h)

if nargin<5
   disp('Faltan argumentos de entrada');
   return;
else
   ts=inicio:h:fin;
   ys(:,1)=alfa;
   n=(fin-inicio)/h;
   for i=1:n
      k1=feval(f,ts(i),ys(:,i));
      k2=feval(f,ts(i)+h/2,ys(:,i)+(h*k1)/2);
      k3=feval(f,ts(i)+h/2,ys(:,i)+(h*k2)/2);
      k4=feval(f,ts(i)+h,ys(:,i)+h*k3);
      fs(:,i)=k1;
      ys(:,i+1)=ys(:,i)+(k1+2*k2+2*k3+k4)*h/6;
   end;
end;
