% Metodo de biparticion para resolucion de
% ecuaciones no lineales de una sola variable
% Uso: sol=bipart(funcion,extremoder,extremoizq,iteraciones,tolerancia)
%
% (C) - Carlos Garcia Argos, 7/VI/2000

function xs=bipart(f,a,b,iter,tol)

if nargin<5
   tol=0;
   if nargin<4
      disp('Error: faltan argumentos de entrada');
      return;
   end;
end;
% Pasamos a dividir sucesivamente el intervalo para buscar la solucion
fin=0;
iteracion=0;
fizq=feval(f,a);
fder=feval(f,b);
if fizq*fder<0
   while (iteracion<iter) & (abs(b-a)>tol) & (fin==0)
      c=(a+b)/2;
      fcent=feval(f,c);
      if (fizq~=0)&(fder~=0)
         if fizq*fcent<0
            b=c;
            fder=fcent;
         elseif (fcent*fder<0)
            a=c;
            fizq=fcent;
         elseif (fder==0)|(fizq==0)
            if fizq==0
               xs=a;
            else
               xs=b;
            end;
            fin=1;
         end;
      end;
      iteracion=iteracion+1;
   end;
   if iteracion>=iter
      disp('Se ha llegado al numero maximo de iteraciones');
      xs=[a b];
   else
      if (fcent==0)|(a==b)
         disp('Se ha encontrado una solucion exacta');
         xs=c;
      else
         disp('Se ha encontrado un intervalo que cumple la tolerancia');
         xs=[a b];
      end;
   end;
else
   disp('Error: no existe ninguna solucion en el intervalo');
end;
