% Metodo de Lin para ecuaciones algebraicas
%
% Uso: [sol,error]=lin(pol,xinicial,maxiter,tol)
%
% La tolerancia por defecto es tol=1e-5
%
% (C) - Carlos Garcia Argos, 18/V/2003

function [xs,errs]=lin(poli,x0,maxiter,tol)

if nargin<4
   tol=1e-5;
end;
if nargin<3
   disp('Error: faltan argumentos de entrada');
   return;
end;

iteraciones=0;
fin=0;
x(1)=x0;

while (iteraciones<maxiter)&(fin==0)
   iteraciones=iteraciones+1;
   an = poli(length(poli));
   x(iteraciones+1)=an*x(iteraciones)/(an-polyval(poli,x(iteraciones)));
   errs=abs(x(iteraciones+1)-x(iteraciones));
   if errs<tol
     fin=1;
   end;
end;

if fin==0
   disp('Se ha llegado al numero maximo de iteraciones');
else
   disp('Se ha encontrado solucion que cumple la tolerancia');
end;

xs=x(iteraciones+1);
