% Metodo de la regula falsi para resolucion de
% ecuaciones no lineales de una sola variable
% Uso: sol=rfalsi(funcion,extizq,extder,iteraciones,tolerancia,error)
%
% El error es el valor maximo de diferencia entre el valor de la
% funcion en el punto y 0.
% 
% (C) - Carlos Garcia Argos, 7/VI/2000

function xs=rfalsi(f,a,b,iter,tol,error)

if nargin<6
   error=0;
elseif nargin<5
   tol=0;
   if nargin<4
      disp('Error: faltan argumentos de entrada');
      return;
   end;
end;
% Pasamos a dividir sucesivamente el intervalo para buscar la solucion
fin=0;
iteracion=0;
fizq=feval(f,a);
fder=feval(f,b);
if fizq*fder<0
   while (iteracion<iter) & (abs(b-a)>tol) & (fin==0)
      c=(b*fizq-a*fder)/(fizq-fder);
      fcent=feval(f,c);
      if (abs(fizq)>error)&(abs(fder)>error)
         if fizq*fcent<0
            b=c;
            fder=fcent;
         elseif (fcent*fder<0)
            a=c;
            fizq=fcent;
         end;
      else
         if abs(fizq)<=error
            xs=a;
         else
            xs=b;
         end;
         fin=1;
      end;
      iteracion=iteracion+1;
   end;
   if iteracion>=iter
      disp('Se ha llegado al numero maximo de iteraciones');
      xs=[a b];
   else
      if (abs(fcent)<error)|(a==b)
         disp('Se ha encontrado una solucion exacta');
         xs=c;
      else
         disp('Se ha encontrado un intervalo que cumple la tolerancia');
         xs=[a b];
      end;
   end;
else
   if fder==0
      xs=b;
   elseif fizq==0
      xs=a;
   else
      disp('Error: no existe ninguna solucion en el intervalo');
   end;
end;
