% Producto escalar funcional
% Calcula <f,g>
%
% Uso: y=prodescf(alfaf,alfag,d,N,tipo,indlf)
%  alfaf: define la autofuncin de f
%  alfag: define la autofuncin de g
%  d: el intervalo es [0,d]
%  N: nmero de puntos en (0,d)
%  tipo: 'tria' (triangular), 'poli' (polinomio)
%        o 'trig' (trigonomtrico), tipo de la
%        funcin peso.
%  indlf: 

function y=prodescf(alfaf,alfag,d,N,tipo,indlf)
if nargin<5
   error('Faltan argumentos de entrada');
end;
if tipo=='tria'
   if nargin<6
      indlf=0; 
   end;
   if indlf
      dpri = 2*(N+1)/d*ones(1,N);
      if N>1
         dsec = (-1)*(N+1)/d*ones(1,N-1); 
      end;
   else
      dpri = (2/3)*d/(N+1)*ones(1,N);
      if N>1
         dsec = (1/6)*d/(N+1)*ones(1,N-1);
      end;
   end;
   if N>1
      P = diag(dsec,-1)+diag(dpri,0)+diag(dsec,1);
   else
      P = diag(dpri,0);
   end;
   y = sum(sum((alfaf*alfag').*P));
elseif nargin>5
   y = quad8('intgando',0,d,[],[],alfaf,alfag,indlf);
else
   y = quad8('intgando',0,d,[],[],alfaf,alfag);
end;
