% Metodo de integracion compuesta
% Escojer el metodo de integracion en los argumentos
% de entrada. El metodo por defecto es Simpson
% Opciones: Simpson, Trapecio, Simpson38, Boole, Pmedio,
% Abierta2, Abierta3, Abierta4
% Uso: sol=intcomp(funcion,a,b,intervalos,metodo)
%
% (C) - Carlos Garcia Argos, 6/VI/2000

function ys=intcomp(f,a,b,m,metodo)
   if nargin<4
      disp('Error: faltan argumentos de entrada');
      return;
   else
      if nargin<5 
         metodo='Simpson';
      end;
   end;

   % Subdivision de los intervalos
   h=(b-a)/m;
   ys=0;

   if strcmp(metodo,'Simpson')
      for k=1:m
         ys=ys+simpson(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Simpson38')
      for k=1:m
         ys=ys+simpso38(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Trapecio')
      for k=1:m
         ys=ys+trapecio(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Boole')
      for k=1:m
         ys=ys+boole(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Pmedio')
      for k=1:m
         ys=ys+pmedio(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Abierta2')
      for k=1:m
         ys=ys+intab2(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Abierta3')
      for k=1:m
         ys=ys+intab3(f,a+(k-1)*h,a+k*h);
      end;
   elseif strcmp(metodo,'Abierta4')
      for k=1:m
         ys=ys+intab4(f,a+(k-1)*h,a+k*h);
      end;
   else
      error('Metodo incorrecto');
   end;
