% Implementacion de metodos para Problemas
% de Valores de Contorno
% Metodo del disparo
%
% Uso: [ts,ys,zs,yzbs]=disparo(funcion,inicio,fin,alfa,beta,disps,h,tol)
%
% (C) - Carlos Garcia Argos 20/VIII/2001
% Extraido de la prctica 2
%

function [ts,ys,zs,yzbs]=disparo(f,inicio,fin,alfa,beta,elevs,disps,h,tol)
m=(fin-inicio)/h+1;
n=length(elevs);
ts=zeros(1,m);
ys=zeros(1,m); 
yst=zeros(n,m);
temp=zeros(2,m);
zs=[]; 
yzbs=[];
for k=1:n
   [ts,temp]=rkc4(f,inicio,fin,[alfa;elevs(k)],h);
   % o bien  [ts,temp]=predcorr(f,inicio,fin,[alfa;elevs(k)],h,'rkc4',4,'ab4','am4');
   yst(k,:)=temp(1,:); zs=[zs elevs(k)]; yzbs=[yzbs yst(k,m)];
end;
if disps==0
   lambda=(beta-yzbs(2))/(yzbs(1)-yzbs(2));
   ys=lambda*yst(1,:)+(1-lambda)*yst(2,:);
else
   zkmenos1=elevs(n); 
   zkmenos2=elevs(n-1);
   phizkmenos1=yzbs(n)-beta; 
   phizkmenos2=yzbs(n-1)-beta;
   k=1;
   while (abs(phizkmenos1-phizkmenos2)>tol) & (k<=disps)
      zk=zkmenos1-(zkmenos1-zkmenos2)/(phizkmenos1-phizkmenos2)*phizkmenos1;
      [ts,temp]=rkc4(f,inicio,fin,[alfa;zk],h);
      % o bien      [ts,temp]=predcorr(f,inicio,fin,[alfa;zk],h,'rkc4',4,'ab4','am4');
      yst(n,:)=temp(1,:);
      zs=[zs zk]; 
      yzbs=[yzbs yst(n,m)];
      zkmenos2=zkmenos1;
      zkmenos1=zk;
      phizkmenos2=phizkmenos1; 
      phizkmenos1=yzbs(n+k)-beta;
      k=k+1;
   end;
   ys=yst(n,:);
end;

