% Metodo de Crout para matrices tridiagonales
%
% Uso: sol=crotridi(diaginf,diagsup,diagprin,b)
%
% Se pasan las diagonales como vectores
%
% (C) - Carlos Garcia Argos, 11/VI/2000

function xs=crotridi(dinf,dsup,dpri,b)

   n=length(dpri);
   xs=zeros(n,1);
   dsup(1)=dsup(1)/dpri(1);
   for k=2:n-1
      dpri(k)=dpri(k)-dinf(k-1)*dsup(k-1); % Clculo de la matriz L
      dsup(k)=dsup(k)/dpri(k);             % Clculo de la matriz R
   end;
   dpri(n)=dpri(n)-dinf(n-1)*dsup(n-1);
   b(1)=b(1)/dpri(1);
   for k=2:n
      b(k)=(b(k)-dinf(k-1)*b(k-1))/dpri(k);
   end;
   xs(n)=b(n);
   for k=n-1:-1:1
      xs(k)=b(k)-dsup(k)*xs(k+1);
   end;
