% Determinar si una matriz A es factorizable
%
% Uso: factoriz(A)
% Devuelve texto explicativo
%
% (C) Carlos Garcia Argos, 5/III/2003
%

function factoriz(A)

% Primero se comprueba que es cuadrada
[m n] = size(A);

if m~=n,
    error('La matriz no es cuadrada');
end;

% Ahora se miran los menores principales sucesivos
% comprobando que son distintos de cero
fin = 0; % Cuando encontremos un menor nulo terminamos el bucle
cont = m-1;

while (fin == 0)&(cont>0),
    Atemp = A(1:cont,1:cont);
    if det(Atemp) == 0,
        fin = 1;
    end;
    cont = cont - 1;
end;

if fin == 1,
    if det(A) == 0,
        disp('No se puede saber si es factorizable, hay que intentar realizar la factorizacion');
    else
        disp('No es factorizable, alguno de los menores principales de la matriz es nulo y el determinante no lo es');
    end;
else
    disp('La matriz es factorizable LU');
end;
