% Metodo del gradiente conjugado para sistemas lineales
%
% Uso: [sol,iter]=gconjsl(A,b,xinicial,maxiter)
% xinicial debe ser un vector columna
%
% (C) - Carlos Garcia Argos, 11/VI/2000

function [xs,iter]=gconjsl(A,b,x0,maxiter)

if nargin<4
   disp('Faltan argumentos de entrada');
   return;
end;

r(:,1) = b - A*x0;  % Residuo inicial
iter = 1;           % Contador de iteraciones
x(:,1) = x0;        % Almacenar las soluciones sucesivas (habria que ahorrar almacenando solo las 2 ultimas)
d(:,1) = r(:,1);    % Direccion de descenso inicial

while (norm(r(:,iter)) ~= 0) & (iter < maxiter)
   alpha = norm(r(:,iter),2)^2/(d(:,iter)'*A*d(:,iter));
   r(:,iter+1) = r(:,iter) - alpha*A*d(:,iter);
   beta = (norm(r(:,iter+1),2)/norm(r(:,iter),2))^2;
   x(:,iter+1) = x(:,iter) + alpha*d(:,iter);
   iter = iter + 1;
   d(:,iter) = r(:,iter) + beta*d(:,iter-1);
end;

xs = x(:,iter);
