% Metodo del gradiente para sistemas lineales
% Uso: [sol,iter]=gradsl(A,b,xinicial,maxiter)
% xinicial debe ser un vector columna
%
% (C) - Carlos Garcia Argos, 11/VI/2000

function [xs,iter]=gradsl(A,b,x0,maxiter)

if nargin<4
   disp('Faltan argumentos de entrada');
   return;
end;

r=b-A*x0;
iter=1;
x(1,:)=x0';
while (norm(r)~=0)&(iter<maxiter)
   alpha=(r'*r)/(r'*A*r);
   x(iter+1,:)=x(iter,:)+alpha*r';
   iter=iter+1;
   r=b-A*x(iter,:)';
end;

xs=x(iter,:);
