% Metodo de Gram-Schmidt para hacer la factorizacion QR reducida
% de una matriz A
%
% Uso: [Q R] = gramsch(A)
%
% (C) Carlos Garcia Argos, 7/III/2003
%

function [Q, R] = gramsch(A)

[m,n] = size(A);

if m<n,
    error('Las dimensiones de la matriz A son incorrectas');
end;

Q = A;
R = zeros(n);

for k=1:n
    for i=1:k-1
        R(i,k) = Q(:,i)'*A(:,k);
        Q(:,k) = Q(:,k) - Q(:,i)*R(i,k);
    end;
    R(k,k) = norm(Q(:,k));
    Q(:,k) = Q(:,k)/R(k,k);
end;