% Metodo de Gram-Schmidt modificado para hacer la factorizacion 
% QR reducida de una matriz A
%
% Uso: [Q R] = gramschmod(A)
%
% (C) Carlos Garcia Argos, 7/III/2003
%

function [Q, R] = gramschmod(A)

[m,n] = size(A);

if m<n,
    error('Las dimensiones de la matriz A son incorrectas');
end;

Q = A;
R = zeros(n);

for k=1:n
    for i=1:k-1
        % Esta es la modificacion: operar con la matriz Q en vez de con A
        R(i,k) = Q(:,i)'*Q(:,k);  
        Q(:,k) = Q(:,k) - Q(:,i)*R(i,k);
    end;
    R(k,k) = norm(Q(:,k));
    Q(:,k) = Q(:,k)/R(k,k);
end;