% Metodo de Householder
%
% Uso: [Ab] = househ(A, b)
% Ab es la matriz ampliada resultante
%
% Transparencias
%

function [Ab] = househ(A, b)

[m n] = size(A);
Ab = [A b];

if m<=n,
   nl = m-1;
else
    nl = n;
end;

for i=1:nl
    v = Ab(i:m,i);
    nor = norm(v);
    if nor > 10*eps;
        signo = sign(v(1));
        if abs(v(1)) < 10*eps,
            signo = 1;
        end;
        v(1) = v(1) + signo*nor;
        Ab(i:m, i:n+1) = Ab(i:m, i:n+1)-(2/(v'*v)*v)*(v'*Ab(i:m, i:n+1));
    end;
end;