% Metodo de Householder con normalizacion
% previa del vector v
%
% Uso: [Ab] = househ2(A, b)
% Ab es la matriz ampliada resultante
%
% Transparencias
%

function [Ah, bh] = househ2(A, b)

[m n] = size(A);
Ab = [A b];

if m<=n,
   nl = m-1;
else
    nl = n;
end;

for i=1:nl
    v = Ab(i:m,i);
    v = v/max(v);
    norma = norm(v); % Con esta normalizacion se puede evitar over/underflow
    if norma > 10*eps;
        signo = sign(v(1));
        if abs(v(1)) < 10*eps,
            signo = 1;
        end;
        v(1) = v(1) + signo*norma;
        Ab(i:m, i:n+1) = Ab(i:m, i:n+1)-(2/(v'*v)*v)*(v'*Ab(i:m, i:n+1));
    end;
end;

Ah = Ab(1:m,1:n);
bh = Ab(1:m,n+1);
