% Funcin que resuelve un sistema lineal por el metodo
% iterativo de Jacobi.
%
% Uso: [solucion,iteraciones]=jacobi(A,b,xinicial,maxiter)
% xinicial debe ser un vector columna
% 
% Se comprueba que la matriz sea cuadrada, que el sistema sea valido
% y que no se ha acabado antes de llegar al numero de iteraciones.
% No trata con errores (todava :-D)
%
% Autor: Carlos Garca Argos, 29/IV/2000

function [X,paso]=jacobi(A,b,x0,iter)

   if nargin<4, 'Faltan argumentos de entrada', return;
   else
      [cols filas]=size(A);
      if cols~=filas, 'La matriz no es cuadrada', return;
      else
         if (cols~=size(x0))|(cols~=size(b))
            error('El sistema no es valido');
         else
% Generamos las matrices D, L y R
            for k=1:cols
               for j=k+1:cols
                  if k~=j
                     D(j,k)=0;
                     D(k,j)=0;
                     L(j,k)=A(j,k);
                     L(k,j)=0;
                     R(k,j)=A(k,j);
                     R(j,k)=0;
                  end;
               end;
               D(k,k)=A(k,k);
               L(k,k)=0;
               R(k,k)=0;
            end;
            fin=0;
            paso=1;
            x(1,:)=x0';
% La condicion de parada adicional es que se llegue a la solucin exacta
            while (fin==0)&(paso<=iter)
               for componente=1:cols
                  vectant=0;
                  vectsig=0;
                  for k=1:componente-1
                     vectant=vectant+A(componente,k)*x(paso,k);
                  end;
                  for k=componente+1:cols
                     vectsig=vectsig+A(componente,k)*x(paso,k);
                  end;
                  x(paso+1,componente)=(b(componente)-vectant-vectsig)/A(componente,componente);
               end;
% Si la solucin es igual a la anterior, salimos del bucle
               if x(paso,:)==x(paso+1,:)
                  fin=1;
               end;
               paso=paso+1;
            end;
% Metemos la ltima solucin en un vector
            X=x(paso,:);
         end;
      end;
   end;

