% Clculo del mximo pivote a partir de una matriz y un nmero de fila
%
% Uso: [pivote] = pivotemax(A,fila,pivotaje)
%
% Devuelve la posicin del pivote
%
% (C) - Carlos Garca Argos, 3/III/2002
%

function [pivote] = pivotemax(A,fila,modo)

if nargin<3
   modo = 'parcial'; % Si no dice nada, presupone pivotaje parcial
   if nargin<2
      fila = 1; % Si no dice nada, presupone que empieza en la primera fila
      if nargin<1
         error('Faltan argumentos de entrada');
      end;
   end;
end;

col = fila;  % A recorrer columnas
maximo = A(fila,col);  % El primero es el pivote
pivote = [fila,col];
fin = 0;
j = col;

if (strcmp(modo,'no') ~= 1)
   while (fin == 0)&(j<=length(A))
      for k = fila:length(A),
         if abs(A(k,j))>abs(maximo)
            maximo = A(k,j);
            pivote = [k,j];
         end;
      end;
      switch modo
      case 'parcial',  % Si es pivotaje parcial nos salimos en la primera iteracin
         fin = 1;
      case 'total',
         j = j + 1;
      end;
   end;
end;