% Funcin que resuelve un sistema lineal por el metodo
% iterativo SOR (sobrerrelajacion)
% Busca el w0 optimo con el que hacer la iteracion
%
% Uso: [solucion,paso]=sor(A,b,xinicial,maxiter)
% xinicial debe ser un vector columna
%
% Se comprueba que la matriz sea cuadrada, que el sistema sea valido
% y que no se ha acabado antes de llegar al numero de iteraciones.
% No trata con errores (todava :-D)
%
% (C) - Carlos Garca Argos, 11/VI/2000

function [X,paso]=sor(A,b,x0,iter)

paso=0;
X=0;
   if nargin<4, 'Faltan argumentos de entrada'
      return;
   end;
   [cols filas]=size(A);
   if cols~=filas
      disp('La matriz no es cuadrada');
      return;
   end;
   if (cols~=size(x0))|(cols~=size(b))
      disp('El sistema no es valido');
      return;
   end;
% Generamos las matrices D, L y R
   for k=1:cols
      for j=k+1:cols
         if k~=j
            D(j,k)=0;
            D(k,j)=0;
            L(j,k)=A(j,k);
            L(k,j)=0;
            R(k,j)=A(k,j);
            R(j,k)=0;
         end;
      end;
      D(k,k)=A(k,k);
      L(k,k)=0;
      R(k,k)=0;
   end;
   fin=0;
   paso=1;
   x(1,:)=x0';
% Vemos si la matriz es tridiagonal
  if tridiag(A)~=0
     disp('La matriz de sistema no es tridiagonal, no se puede usar este metodo');
     return;
  end;

% Montamos la matriz de Jacobi
  Bj=-inv(D)*(L+R);
  z=eig(Bj);
  t=max(z);
  w0=2/(1+sqrt(1-t^2));
  [X,paso]=sor(A,b,x0,w0,iter);
