% Metodo de sustitucion progresiva para sistemas de ecuaciones lineales
%
% Uso: [x] = sustprog(A, b)
%
% (C) - Carlos Garcia Argos, 5/III/2003
%

function [x] = sustprog(A, b)


% Es vlido el sistema?
[M,N] = size(A);
tam = length(b);
if (M ~= N)|(tam ~= M)
   error('Las dimensiones del sistema no son vlidas');
end;

% Vector de soluciones
x = zeros(tam,1);

x(1) = b(1)/A(1,1);

for k = 2:1:tam,
   suma = x(1:k-1)'*A(k,1:k-1)';
   x(k) = (b(k)-suma)/A(k,k);
end;

